
# Module for accessing cgi-parameters

namespace eval CGI {
	# Returns a list containing all parameters in the form 
	# { {{NAME1} {VALUE1}} {{NAME2} {VALUE2}} {{NAME3} {VALUE3}} }...
	namespace export get_Parameter_List
		
	# Returns the first value of the requested parameter as plain text
	namespace export get_Parameter
}


########################################################################
###########################    Oeffentlich    ##########################
########################################################################


# Adapter for the xml2html-function "get_cgi_argl"
proc CGI::get_Parameter_List {} {
	return [get_cgi_argl]
}


########################################################################


# get first value of a parameter by discarding all the empties 
proc CGI::get_Parameter { {name {}} } {
	# only start search if a name was specified
	if {[string length "$name"] > 0} {
		# get list of parameters with this name
		set lst [getParameterByName "$name"]

		set result ""
		set index 0

		# iterate through list, until non-empty value was found
		# or end of list is reached
		while	{	([string length $result] == 0) 
				&&	($index <= [llength $lst])
		} {
			set result "[lindex $lst $index]"
			incr index
		}

		# return the value found, or empty string, if no non-empty values
		# where in the list
		return "$result"
	}
	
	# if no name was specified, return empty string
	return ""
}


########################################################################
##############################   Privat   ##############################
########################################################################


# Adapter for the xml2html-function "get_cgi_arg"
proc CGI::getParameterByName	{	{name {}} 
										}	{
	return [get_cgi_arg "$name" ""]
}	


########################################################################

