
namespace eval ComplexInput {
	namespace export listbox
	namespace export dropdown
	namespace export radiobutton_Group
	namespace export td_Radiobutton_Group
	namespace export checkbox_Group
	namespace export td_Checkbox_Group
	namespace export hidden_Group
	namespace export button_Group
	namespace export td_Button_Group
	namespace export td_Title
	namespace export parameter_Refresh
	namespace export generator_Link
	namespace export form_Link
	namespace export unknown_Element
}


########################################################################
###########################    Oeffentlich    ##########################
########################################################################


proc ComplexInput::listbox	{	{items {}}
										{name {listbox}}
										{size 7}
										{width {100%}}
										{allowmultipleselection ""}
										{default ""}
										args
									}	{
	if {[Util::is_True $allowmultipleselection]} {
		set multiple " multiple"
	} else {
		set multiple ""
	}
	if {[string equal "NULL" "$default"]} {
		append result [subst {<INPUT type="hidden" name="$name" value="NULL"></INPUT>}]
	}
	set result [subst {<SELECT name="$name" size="$size"$multiple>}]
	if {[string length "$default"] < 1} {
		append result [nullOption "$width"]
	}
	foreach {opt} "$items" {
		append result [option "$opt" "$width" "$default"] 
	}
	append result {</SELECT>}
	return [subst {$result}]
}


########################################################################


proc ComplexInput::dropdown	{	{items {}}
											{name {dropdown}}
											{width {100%}}
											{default ""}
											args
										}	{
	return "[listbox "$items" "$name" 1 "$width" 0 "$default"]"
}


########################################################################


proc ComplexInput::radiobutton_Group	{	{items {}}
														{name {radiogroup}}
														{align {vertical}}
														{default ""}
														args
													}	{
	set result {}
	if {[string equal "NULL" "$default"]} {
		append result [subst {<INPUT type="hidden" name="$name" value="NULL"></INPUT>}]
	}
	foreach {opt} "$items" {
		append result [input "radio" "$name" "$opt" "$default"]
		if {[string equal "$align" "vertical"]} {
			append result {<BR>}
		} else {
			append result { }
		}
	}
	if {[string length "$default"] < 1} {
		append result [nullInput "radio" "$name"]
	}
	return $result
}


########################################################################


proc ComplexInput::td_Radiobutton_Group	{	{items {}}
															{name {radiogroup}}
															{align {horizontal}}
															{textalign {behind}}
															{optalign {right}}
															{default ""}
															{type ""}
															args
														}	{
	set result {}
	if {[string equal -nocase "horizontal" "$align"]} {
		set optalign center
	}
	if {[string equal "NULL" "$default"]} {
		append result [subst {<INPUT type="hidden" name="$name" value="NULL"></INPUT>}]
	}
	foreach {opt} "$items" {
		append result [tabledInput "radio" "$name" "$opt" "$textalign" "$optalign" "$default"]
		if {[string equal "$align" "vertical"]} {
			append result {</TR><TR>}
		}
	}
	if {[string length "$default"] < 1} {
		append result [tabledNullInput "radio" "$name" "$textalign" "$optalign" "$type"]
	}
	
	return $result
}


########################################################################


proc ComplexInput::checkbox_Group	{	{items {}}
													{name {checkboxgroup}}
													{align {vertical}}
													{default ""}
													args
												}	{
	set result {}
	if {[string equal "NULL" "$default"]} {
		append result [subst {<INPUT type="hidden" name="$name" value="NULL"></INPUT>}]
	}
	foreach {opt} "$items" {
		append result [input "checkbox" "$name" "$opt" "$default"]
		if {[string equal "$align" "vertical"]} {
			append result {<BR>}
		} else {
			append result { }
		}
	}
	if {[string length "$default"] < 1} {
		append result [nullInput "checkbox" "$name"]
	}

	return $result
}


########################################################################


proc ComplexInput::td_Checkbox_Group	{	{items {}}
														{name {checkboxgroup}}
														{align {horizontal}}
														{textalign {behind}}
														{optalign {right}}
														{default ""}
														{type ""}
														args
													}	{
	set result {}
	if {[string equal "NULL" "$default"]} {
		append result [subst {<INPUT type="hidden" name="$name" value="NULL"></INPUT>}]
	}
	if {[string equal -nocase "horizontal" "$align"]} {
		set optalign center
	}
	foreach {opt} "$items" {
		append result [tabledInput "checkbox" "$name" "$opt" "$textalign" "$optalign" "$default"]
		if {[string equal "$align" "vertical"]} {
			append result {</TR><TR>}
		}
	}
	if {[string length "$default"] < 1} {
		append result [tabledNullInput "checkbox" "$name" "$textalign" "$optalign" "$type"]
	}
	return $result
}


########################################################################


proc ComplexInput::hidden_Group	{	{items {}}
												args
											}	{
	set result {}
	foreach pair "$items" {
		set name [splitNameValue {pair}]
		append result [subst {<INPUT type="hidden" name="$name" value="$pair">\n}]
	}
	return $result
}


########################################################################


proc ComplexInput::button_Group	{	{items {}}
												{align {vertical}}
												args
											}	{
	set result {}
	foreach {pair} "$items" {
		set nameValue [split "$pair" {=}]
		append result [input	"button" \
									"[lindex $nameValue 0]" \
									"[join [lrange $nameValue 1 end] {=}]"]
		if {[string equal "$align" "vertical"]} {
			append result {<BR>}
		} else {
			append result {&nbsp;}
		}
	}

	return $result	
}


########################################################################


proc ComplexInput::td_Button_Group	{	{items {}}
													{align {horizontal}}
													args
												}	{
	set result {}
	foreach {pair} "$items" {
		set nameValue [split "$pair" {=}]
		append result {<TD>}
		append result [input	"button" \
									"[lindex $nameValue 0]" \
									"[join [lrange $nameValue 1 end] {=}]"]
		append result {</TD>}
		if {[string equal "$align" "vertical"]} {
			append result {</TR><TR>}
		} 
	}
	return $result
}


########################################################################


proc ComplexInput::td_Title	{	{items {}}
											{default ""}
										}	{
	set result {}
	foreach {opt} "$items" {
		append result [subst {<TD align="center" valign="bottom">[string trim "$opt"]</TD>}]
	}
	if {[string length "$default"] < 1} {
		append result {<TD align="center" valign="bottom">Unbeantwortet</TD>}
	}

	return "$result"
}


########################################################################


proc ComplexInput::parameter_Refresh	{	{parameterlist {}} 
														args
													}	{
	set namevaluelist {}
	foreach parameter $parameterlist {
		lappend namevaluelist "$parameter=[CGI::get_Parameter $parameter]"
	}
	return "[hidden_Group $namevaluelist]"
}


########################################################################


proc ComplexInput::generator_Link {args} {
	set formid [CGI::get_Parameter "FORMID"]
	if {[string length $formid] > 0} {
		set result [subst {
			<A href="./index.html?FORMID=$formid&ACTION=fbg_generate" target="_blank">Fragebogen generieren</A>
		}]
		if {[Util::is_In_List $args "-plain"]} {
			return $result
		} else {
			return "<P>$result</P>"
		}
	} else {
		return ""
	}
}


########################################################################


proc ComplexInput::form_Link {args} {
	set formid [CGI::get_Parameter "FORMID"]
	set password [CGI::get_Parameter "FRM_PASSWORD"]
	if {[string length $formid] > 1} {
		set result [subst {<P>
			<A href="./index.html?FORMID=$formid&ACTION=fbg_edit&FRM_PASSWORD=$password"
				target="_top">Zur&uuml;ck zur Fragebogen-Seite</A>
			</P>
		}]
		return $result
	} else {
		return ""
	}
}


########################################################################


proc ComplexInput::unknown_Element	{	args
												}	{
	return {[unbekanntes Element]}
}


########################################################################
##############################   Privat   ##############################
########################################################################


proc ComplexInput::option	{	{namevalue {}}
										{width {100%}}
										{default ""}
									}	{
	set value [splitNameValue {namevalue}]
	if	{	([string length "$default"] > 0)
		&&	([string equal -nocase "$value" "$default"])
	}	{
		set markdefault " selected"
	} else {
		set markdefault ""
	}
	set result {<OPTION value="$value" width="$width"$markdefault>$namevalue</OPTION>}
	return [subst "$result\n"]
}


########################################################################

proc ComplexInput::nullOption	{ {width "100%"} }	{
	set result {<OPTION value="NULL" width="$width" selected>Unbeantwortet</OPTION>}
	return [subst "$result\n"]
}


########################################################################


proc ComplexInput::input	{	{type {button}}
										{groupname {unbenannt}}
										{namevalue {}}
										{default ""}
									}	{
	if {[string length $namevalue] < 1} {
		return ""
	} 
	if {	([string equal -nocase "<br>" "$namevalue"])
		&&	(	([string equal -nocase "$type" "checkbox"])
			||	([string equal -nocase "$type" "radio"])
			||	([string equal -nocase "$type" "button"])
			)
	}	{
		return "<BR>"
	}
	set value [splitNameValue {namevalue}]
	if	{	(	([string equal -nocase "$type" "checkbox"])
			||	([string equal -nocase "$type" "radio"])	)
		&&	([string length "$default"] > 0)
		&&	([string equal -nocase "$value" "$default"])
	}	{
		set markdefault " checked"
	} else {
		set markdefault ""
	}
	set result {<INPUT type="$type" name="$groupname" value="$value"$markdefault>}
	if {	([string equal -nocase "$type" "checkbox"])
		||	([string equal -nocase "$type" "radio"])
	} {
		append result [string trim "$namevalue"]
	}
	append result {</INPUT>}
	return [subst "$result\n"]
}


########################################################################


proc ComplexInput::nullInput	{	{type {hidden}}
											{groupname {unbenannt}}
										}	{
	set result {
		<INPUT type="$type" name="$groupname" value="NULL" checked>
			Unbeantwortet
		</INPUT>
	}
	return [subst "$result\n"]
}


########################################################################


proc ComplexInput::tabledInput	{	{type {checkbox}}
												{groupname {unbenannt}}
												{namevalue {}}
												{textalign {behind}}
												{optalign {right}}
												{default ""}
											}	{
	if	{	([string length $namevalue] < 1)
		||	(!	(	([string equal -nocase "$type" "checkbox"])
				||	([string equal -nocase "$type" "radio"])
				||	([string equal -nocase "$type" "button"])
				)
			)
	}	{
		return ""
	} 
	if {[string equal -nocase "<br>" "$namevalue"]} {
		return "<TD>&nbsp;</TD>"
	}
	set value [splitNameValue {namevalue}]
	if	{	(	([string equal -nocase "$type" "checkbox"])
			||	([string equal -nocase "$type" "radio"])	)
		&&	([string length "$default"] > 0)
		&&	([string equal -nocase "$value" "$default"])
	}	{
		set markdefault " checked"
	} else {
		set markdefault ""
	}
	switch -exact -- $textalign {
		behind {
			set result [subst {<INPUT type="$type" name="$groupname" value="$value"$markdefault>}]
			append result [string trim "$namevalue"]
		}
		before {
			set result "[string trim "$namevalue"]"
		  append result [subst {<INPUT type="$type" name="$groupname" value="$value"$markdefault>}]
		}
		above {
			set result "[string trim "$namevalue"]<BR>"
			append result [subst {<INPUT type="$type" name="$groupname" value="$value"$markdefault>}]
		}
		below {
			set result [subst {<INPUT type="$type" name="$groupname" value="$value"$markdefault>}]
			append result "<BR>[string trim "$namevalue"]"
		}
		default {
			set result [subst {<INPUT type="$type" name="$groupname" value="$value"$markdefault>}]
			append result [string trim "$namevalue"]
		}
	}
	append result {</INPUT>}
	return [subst {<TD align="$optalign">$result</TD>\n}]
}


########################################################################


proc ComplexInput::tabledNullInput	{	{type {checkbox}}
													{groupname {unbenannt}}
													{textalign {behind}}
													{optalign {right}}
													{kind ""}
												}	{
	if {[string equal "block" [string tolower "$kind"]]} {
		set text ""
	} else {
		set text "Unbeantwortet"
	}

	switch -exact -- $textalign {
		behind {
			set result [subst {<INPUT type="$type" name="$groupname" value="NULL" checked>}]
			append result "$text"
		}
		before {
			set result "$text"
			append result [subst {<INPUT type="$type" name="$groupname" value="NULL" checked>}]
		}
		above {
			set result "$text<BR>"
			append result [subst {<INPUT type="$type" name="$groupname" value="NULL" checked>}]
		}
		below {
			set result [subst {<INPUT type="$type" name="$groupname" value="NULL" checked>}]
			append result "<BR>$text"
		}
		default {
			set result [subst {<INPUT type="$type" name="$groupname" value="NULL" checked>}]
			append result "$text"
		}
	}
	append result {</INPUT>}
	return [subst {<TD align="$optalign">$result</TD>\n}]
}


########################################################################


proc ComplexInput::splitNameValue	{ {varname {name}} 
												} {
	upvar 1 $varname name

	set nameValue [split "$name" {=}]
	set value [lindex $nameValue 0]
	
	if {[llength $nameValue] < 2} {
		set name $value
	} else {
		set name [join [lrange $nameValue 1 end] {=}]
	}

	return "$value"
}


########################################################################

