#!/usr/bin/tclsh

set INFOFILE {tcl/dbinfo.tcl}

catch {
	if {[file exists $INFOFILE]} {source $INFOFILE}
}

if {[info exists global_options(DBNAME)]} {
	set DBNAME_default $global_options(DBNAME)
} else {
	set DBNAME_default {Fragebogengenerator}
}

if {[info exists global_options(DBUSER)]} {
	set DBUSER_default $global_options(DBUSER)
} else {
	set DBUSER_default {FBErsteller}
}

if {[info exists global_options(DBHOST)]} {
	set DBHOST_default $global_options(DBHOST)
} else {
	set DBHOST_default localhost
}

if {[info exists global_options(DBPASS)]} {
	set DBPASS_default $global_options(DBPASS)
} else {
	set DBPASS_default {}
}

if {[info exists global_options(TBL_FORMDATA)]} {
	set TBL_FORMDATA_default $global_options(TBL_FORMDATA)
} else {
	set TBL_FORMDATA_default {formdata}
}

if {[info exists global_options(TBL_RESULTS)]} {
	set TBL_RESULTS_default $global_options(TBL_RESULTS)
} else {
	set TBL_RESULTS_default {results}
}

if {[info exists global_options(RESULTLOG)]} {
	set RESULTLOG_default $global_options(RESULTLOG)
} else {
	set RESULTLOG_default {resultlog}
}



set i 0
foreach arg $argv {
	switch $i {
		0 {
			if {$arg=={}} {set DBNAME $DBNAME_default} else {set DBNAME $arg}
		}

		1 {
			if {$arg=={}} {set DBUSER $DBUSER_default} else {set DBUSER $arg}
		}

		2 {
			if {$arg=={}} {set DBHOST $DBHOST_default} else {set DBHOST $arg}
		}

		3 {
			if {$arg=={}} {set DBPASS $DBPASS_default} else {set DBPASS $arg}
		}

		4 {
			if {$arg=={}} {set TBL_FORMDATA $TBL_FORMDATA_default} else {set TBL_FORMDATA $arg}
		}

		5 {
			if {$arg=={}} {set TBL_RESULTS $TBL_RESULTS_default} else {set TBL_RESULTS $arg}
		}

		6 {
			if {$arg=={}} {set RESULTLOG $RESULTLOG_default} else {set RESULTLOG $arg}
		}
	}
	incr i
}

puts "DBNAME: $DBNAME"
puts "DBUSER: $DBUSER"
puts "DBHOST: $DBHOST"
puts "DBPASS: $DBPASS"
puts "TBL_FORMDATA: $TBL_FORMDATA"
puts "TBL_RESULTS: $TBL_RESULTS"
puts "RESULTLOG: $RESULTLOG"

set f [open $INFOFILE w]

puts $f "set global_options(DBNAME) $DBNAME"
puts $f "set global_options(DBUSER) $DBUSER"
puts $f "set global_options(DBHOST) $DBHOST"
puts $f "set global_options(DBPASS) $DBPASS"
puts $f "set global_options(TBL_FORMDATA) $TBL_FORMDATA"
puts $f "set global_options(TBL_RESULTS) $TBL_RESULTS"
puts $f "set global_options(RESULTLOG) $RESULTLOG"

close $f
