# -----------------------------------------------------------------------------
# FILE:    dbcutil.tcl
#
# PURPOSE: utility functionality for database connectivity 
#
# ----------------------------------------------------------------------------

proc process_INIT-COLORED-TR args {
	global global_options
	
	array set params {
		COLORS     "#cecece, #dcdcdc"
	}

	array set params $args

	set colors [split $params(COLORS) ","]
	
	trc process_INIT-COLORED-TR "colors : $colors"

	set global_options(__color_list) $colors
	set global_options(__color_counter) 0

	return ""
}
# ----------------------------------------------------------------------------

# ----------------------------------------------------------------------------
proc process_COLORED-TR args {
	global global_options
	
	array set params $args

	array set params {
		VALUE     ""
	}
	
	array set params $args
	set val [parse_html_text $params(VALUE)] 

	set listlength [llength $global_options(__color_list)]
	set pos [expr [incr global_options(__color_counter)] % $listlength]

	set bgcolor  [string trim [lindex $global_options(__color_list) $pos]]

	set attrv ""
	foreach attr [array names params] {
		if {[string tolower $attr] != {bgcolor} && [string tolower $attr] != {value}} {
			append attrv " $attr=\"$params($attr)\""
		}
    }

	return  "<tr bgcolor=\"$bgcolor\" $attrv>$val</tr>"
}
# ----------------------------------------------------------------------------


# ----------------------------------------------------------------------------
# helper & filter methods
# ----------------------------------------------------------------------------
proc createCommaSeperatedList list {
	trc createCommaSeperatedList "$list"
	return [join $list ","]
}

# ----------------------------------------------------------------------------

# ----------------------------------------------------------------------------
# global stuff

define_compound_tag "<colored-tr>value</colored-tr>"

trc_register { 
	-process_INIT-COLORED-TR
	-process_COLORED-TR
	createCommaSeperatedList
}
