
namespace eval Element {
	namespace export copy
	namespace export delete
	namespace export edit
	namespace export insert	
	namespace export append_Element
	namespace export move	
	namespace export misc
}


########################################################################
###########################    Oeffentlich    ##########################
########################################################################


proc Element::copy	{	{formid {}}
								{password {}}
								{orderno {}}
							}	{
	set checkresult [Util::check_FormID_And_Password "$formid" "$password"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	} 
	set checkresult [Util::check_OrderNo "$formid" "$orderno"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	} 
	
	set type [DBOperations::get_Element_Type "$formid" "$orderno"]

	return 	[subst {[Generator::build_Page \
				"Element kopieren" \
				"[navigation $formid $password]" \
				"[copyContent $formid $type]" \
	]} ]
}


########################################################################


proc Element::delete	{	{formid {}}
								{password {}}
								{orderno {}}
							}	{
	set checkresult [Util::check_FormID_And_Password "$formid" "$password"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	} 
	set checkresult [Util::check_OrderNo "$formid" "$orderno"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	} 

	return 	[subst {[Generator::build_Page \
				"Element l&ouml;schen" \
				"[navigation $formid $password]" \
				"[deleteContent]" \
	]} ]
}


########################################################################


proc Element::edit	{	{formid {}}
								{password {}}
								{orderno {}}
							}	{
	set checkresult [Util::check_FormID_And_Password "$formid" "$password"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	} 
	set checkresult [Util::check_OrderNo "$formid" "$orderno"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	} 

	set type [DBOperations::get_Element_Type "$formid" "$orderno"]
	set defaults [DBOperations::select_OrderNo "$formid" "$orderno"]
	
	return 	[subst {[Generator::build_Page \
				"Element bearbeiten" \
				"[navigation $formid $password]" \
				"[editContent $type $defaults]" \
	]} ]
}


########################################################################


proc Element::insert	{	{formid {}}
								{password {}}
								{orderno {}}
								{type {}}
							}	{
	set checkresult [Util::check_FormID_And_Password "$formid" "$password"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	} 
	set checkresult [Util::check_OrderNo "$formid" "$orderno" "nice"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	} 
	
	return 	[subst {[Generator::build_Page \
				"Element einf&uuml;gen" \
				"[navigation $formid $password]" \
				"[insertContent $type]" \
	]} ]
}


########################################################################


proc Element::append_Element	{	{formid {}}
											{password {}}
											{type {}}
										}	{
	set checkresult [Util::check_FormID_And_Password "$formid" "$password"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	} 

	return 	[subst {[Generator::build_Page \
				"Element anh&auml;ngen" \
				"[navigation $formid $password]" \
				"[appendContent $type]" \
	]} ]
}


########################################################################


proc Element::move	{	{formid {}}
								{password {}}
								{orderno {}}
							}	{
	set checkresult [Util::check_FormID_And_Password "$formid" "$password"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	} 
	set checkresult [Util::check_OrderNo "$formid" "$orderno"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	} 

	return 	[subst {[Generator::build_Page \
				"Element verschieben" \
				"[navigation $formid $password]" \
				"[moveContent $formid]" \
	]} ]
}


########################################################################


proc Element::misc	{	{formid {}}
								{password {}}
							}	{
	set checkresult [Util::check_FormID_And_Password "$formid" "$password"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	} 

	set defaults [DBOperations::select_OrderNo "$formid" "0"]

	return 	[subst {[Generator::build_Page \
				"Allgemeine Informationen &auml;ndern" \
				"[navigation $formid $password]" \
				"[miscContent $defaults]" \
	]} ]
}


########################################################################
##############################   Privat   ##############################
########################################################################


proc Element::navigation	{	{formid {}}
										{password {}}
									}	{
	set formid [trans_cgi_str "$formid"]
	set password [trans_cgi_str "$password"]
	return [subst {
		<body-elementnavigation formid="$formid" password="$password">
	}]
}


########################################################################


proc Element::copyContent	{	{formid {}}
										{elementtype ""} 
									}	{
	set elementlist [DBOperations::build_Element_List $formid]
	set lastindex [expr [llength $elementlist] + 1]
	lappend elementlist "$lastindex=Am Ende anf&uuml;gen"
	set result [subst {		
		<form-begin>
			<form-parameterrefresh items="{FORMID FRM_PASSWORD ORDERNO}">
			<form-dboperation type="el_copy">
			<form-hiddengroup items="{TYPE=$elementtype}">
			<form-element label="An Position kopieren vor:" valign="center">
	}]
	append result [ComplexInput::listbox "$elementlist" "ORDERNO_NEW" "1" "100%" "" "$lastindex"]

	if {[string compare -length 4 "QST_" "$elementtype"] == 0} {
		append result [subst {
			</form-element>
			<form-element label="Fragenummer:" valign="center">
				<form-text cginame="QST_NUMBER" size="5">
			</form-element>
			<form-element label="Frage:" valign="top">
				<form-memo cginame="QST_TEXT">
			</form-element>
		}]
	} elseif {[string equal -nocase "TEXT" "$elementtype"]} {
		append result [subst {
			</form-element>
			<form-element label="Text:" valign="top">
				<form-memo cginame="TXT_TEXT">
			</form-element>
		}]
	} else {
		append result "</form-element>"
	}
	append result [subst {
			<form-defaultbuttons>
		<form-end>
	}]

	return "$result"
}


########################################################################


proc Element::deleteContent {} {
	set result [subst -nocommands {
		<headline-page text="Wollen Sie dieses Element wirklich L&Ouml;SCHEN?">
		<body-paragraph>
			Klicken Sie auf [Element L&Ouml;SCHEN], wenn Sie dieses Element 
			wirklich endg&uuml;ltig vernichten wollen.
		</body-paragraph>
		<body-paragraph class="important">
			ACHTUNG: Diese Aktion kann nicht r&uuml;ckgngig gemacht werden. Die 
			gel&ouml;schten Daten sind unwiderbringlich verloren und k&ouml;nnen nicht 
			wiederhergestellt werden.
		</body-paragraph>
		<form-begin>
			<form-parameterrefresh items="{FORMID FRM_PASSWORD ORDERNO}">
			<form-dboperation type="el_delete">
			<form-buttons submit="Element LSCHEN">
		<form-end>
	}]
	return "$result"
}


########################################################################


proc Element::editContent	{	{elementtype ""}
										{defaults {}}
									}	{
	return [editor "$elementtype" "el_edit" 1 $defaults]
}


########################################################################


proc Element::insertContent { {elementtype ""} } {
	return [editor "$elementtype" "el_insert"]
}


########################################################################


proc Element::appendContent { {elementtype ""} } {
	return [editor "$elementtype" "el_append"]
}


########################################################################


proc Element::moveContent { {formid {}} } {
	set elementlist [DBOperations::build_Element_List $formid]
	set lastindex [expr [llength $elementlist] + 1]
	lappend elementlist "$lastindex=Am Ende anf&uuml;gen"
	set result [subst {		
		<form-begin>
			<form-parameterrefresh items="{FORMID FRM_PASSWORD ORDERNO}">
			<form-dboperation type="el_move">
			<form-element label="Neue Position vor:" valign="center">
	}]
	append result [ComplexInput::listbox "$elementlist" "ORDERNO_NEW" "1" "100%" "" "$lastindex"]
	append result [subst {
			</form-element>
			<form-defaultbuttons>
		<form-end>
	}]

	return "$result"
}


########################################################################


proc Element::miscContent { {defaultlist {}} } {
	array set defaults $defaultlist
	set result [subst {		
		<form-begin>
			<form-parameterrefresh items="{FORMID FRM_PASSWORD}">
			<form-dboperation type="fbg_edit">
			<template-formmiscinfo
				frm_title="[getDefault defaults "FRM_TITLE"]"
				frm_created_by="[getDefault defaults "FRM_CREATED_BY"]"
				frm_bg_color="[getDefault defaults "FRM_BG_COLOR"]"
				frm_fg_color="[getDefault defaults "FRM_FG_COLOR"]"
				frm_description="[getDefault defaults "FRM_DESCRIPTION"]"
			>
			<form-defaultbuttons>
		<form-end>
	}]

	return "$result"
}


########################################################################


proc Element::editor	{	{elementtype ""}
								{operation "el_insert"}
								{usedefaults 0}
								{defaultlist {}}
							}	{	
	if {$usedefaults} {
		array set defaults $defaultlist
	}
														
	set result [subst {
		<form-begin>
			<form-parameterrefresh items="{FORMID FRM_PASSWORD ORDERNO}">
			<form-dboperation type="$operation">
			<form-hiddengroup items="{TYPE=$elementtype}">
	}]
	switch -exact -- $elementtype {
		TEXT {
			append result [subst {
				<template-text
					txt_text="[getDefault defaults "TXT_TEXT"]"
					txt_alignment="[getDefault defaults "TXT_ALIGNMENT" "left"]"
					txt_size="[getDefault defaults "TXT_SIZE" "0"]"
					txt_color="[getDefault defaults "TXT_COLOR" "#ffffff"]"
					txt_link_target="[getDefault defaults "TXT_LINK_TARGET"]">
			}]
		}
		SEPERATOR {
			append result [subst {
				<template-seperator
					sep_type="[getDefault defaults "SEP_TYPE" "hr"]"
					sep_data="[getDefault defaults "SEP_DATA"]">
			}]
		}
		QST_SELECT {
			append result [subst {
				<template-questionscommonsection 
					qst_number="[getDefault defaults "QST_NUMBER"]"
					qst_show_number="[getDefault defaults "QST_SHOW_NUMBER" "ja"]"
					qst_text="[getDefault defaults "QST_TEXT"]"
					qst_alignment="[getDefault defaults "QST_ALIGNMENT" "left"]">
				<template-selectquestionscommonsection
					inp_sel_option_values="[getDefault defaults "INP_SEL_OPTION_VALUES"]"
					inp_sel_default="[getDefault defaults "INP_SEL_DEFAULTS"]">
				<template-selectquestion
					qst_answer_alignment="[getDefault defaults "QST_ANSWER_ALIGNMENT" "aaar"]"
					inp_sel_type="[getDefault defaults "INP_SEL_TYPE" "radio"]"
					inp_sel_align_text="[getDefault defaults "INP_SEL_ALIGN_TEXT" "behind"]"
					inp_sel_align_options="[getDefault defaults "INP_SEL_ALIGN_OPTIONS" "horizontal"]">
			}]
		}
		QST_TEXT {
			append result [subst {
				<template-questionscommonsection 
					qst_number="[getDefault defaults "QST_NUMBER"]"
					qst_show_number="[getDefault defaults "QST_SHOW_NUMBER" "ja"]"
					qst_text="[getDefault defaults "QST_TEXT"]"
					qst_alignment="[getDefault defaults "QST_ALIGNMENT" "left"]">
				<template-textquestion
					qst_answer_alignment="[getDefault defaults "QST_ANSWER_ALIGNMENT" "aaar"]"
					inp_txt_length="[getDefault defaults "INP_TXT_LENGTH" 255]"
					inp_txt_width="[getDefault defaults "INP_TXT_WIDTH" 50]"
					inp_txt_height="[getDefault defaults "INP_TXT_HEIGHT" 3]">
			}]
		}
		QST_BLOCK {
			append result [subst {
				<template-questionscommonsection 
					qst_number="[getDefault defaults "QST_NUMBER"]"
					qst_show_number="[getDefault defaults "QST_SHOW_NUMBER" "ja"]"
					qst_text="[getDefault defaults "QST_TEXT"]"
					qst_alignment="[getDefault defaults "QST_ALIGNMENT" "left"]">
				<template-selectquestionscommonsection
					inp_sel_option_values="[getDefault defaults "INP_SEL_OPTION_VALUES"]"
					inp_sel_default="[getDefault defaults "INP_SEL_DEFAULTS"]">
				<template-blockquestion
					inp_sel_type="[getDefault defaults "INP_SEL_TYPE" "radio"]"
					inp_sel_block_values="[getDefault defaults "INP_SEL_BLOCK_VALUES"]"
					inp_sel_sub_qst_alignment="[getDefault defaults "INP_SEL_SUB_QST_ALIGNMENT" "right"]">
			}]
		}
		default { 
			append result [subst {
				<headline-page text="Unbekannter Elementtyp &quot;$elementtype&quot;">
			}]
		}
	}
	
	append result [subst {
			<form-defaultbuttons>
		<form-end>
	}]
		
	return "$result"
}


########################################################################


proc Element::getDefault	{	{defaultarrayname ""}
										{element ""}
										{default ""}
									}	{

	if	{	([string length $defaultarrayname] < 1)
		||	([string length $element] < 1)
	}	{
		return "$default"
	} else {
		upvar 1 $defaultarrayname defaults
		if {[catch {set value $defaults($element)}]} {
			return "$default"
		} else {
			return "$value"
		}
	}
}
