
namespace eval Form {
	namespace export copy
	namespace export delete
	namespace export edit
	namespace export new
	namespace export rename_Form
}	


########################################################################
###########################    Oeffentlich    ##########################
########################################################################


proc Form::copy	{ 	{formid {}}
							{password {}}
						}	{
	set checkresult [Util::check_FormID_And_Password "$formid" "$password"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	}
	
	set oldtitle [DBOperations::get_Form_Title $formid]
	return 	[subst {[Generator::build_Page \
				"Fragebogen kopieren" \
				"[navigation]" \
				"[copyContent $oldtitle]" \
	]} ]
	
}


########################################################################


proc Form::delete { 	{formid {}}
							{password {}}
						}	{
	set checkresult [Util::check_FormID_And_Password "$formid" "$password"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	} 

	set title [DBOperations::get_Form_Title $formid]
	return 	[subst {[Generator::build_Page \
				"Fragebogen l&ouml;schen" \
				"[navigation]" \
				"[deleteContent $title]" \
	]} ]
}


########################################################################


proc Form::edit	{	{formid {}}
							{password {}}
						}	{
	set checkresult [Util::check_FormID_And_Password "$formid" "$password"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	} 

	return 	[subst {[Generator::build_Page \
				"Fragebogen bearbeiten" \
				"[navigation]" \
				"[editContent $formid]" \
	]} ]
}


########################################################################


proc Form::new {} {
	return [subst {[Generator::build_Page \
			"Fragebogen anlegen" \
			"[navigation]" \
			"[newContent]" \
	]} ]
}


########################################################################


proc Form::rename_Form	{	{formid {}}
									{password {}}
								}	{
	set checkresult [Util::check_FormID_And_Password "$formid" "$password"]
	if {[string length "$checkresult"] > 0} {
		return $checkresult
	}
	
	set oldtitle [DBOperations::get_Form_Title $formid]
	return [subst {[Generator::build_Page \
				"Fragebogen umbenennen" \
				"[navigation]" \
				"[renameContent $oldtitle]" \
	]} ]
}


########################################################################
##############################   Privat   ##############################
########################################################################


proc Form::navigation {} {
	return "<body-defaultnavigation>"
}


########################################################################


proc Form::copyContent { {oldtitle {}} } {
	set result [subst -nocommands {
		<body-paragraph>
			Wenn Sie den Fragebogen mit dem Titel "$oldtitle" komplett
			kopieren wollen, geben Sie bitte einen neuen Titel sowie ein 
			Pa&szlig;wort fr die Kopie an.
		</body-paragraph>
		<form-begin>
			<form-parameterrefresh items="{FORMID FRM_PASSWORD}">
			<form-dboperation type="fbg_copy">
			<form-element label="Titel:" valign="center">
				<form-text cginame="FRM_TITLE" value="Kopie von: $oldtitle">
			</form-element>
			<form-element label="Passwort:" valign="center">
				<static-password cginame="FRM_PASSWORD_NEW">
			</form-element>
			<form-element label="Passwort wiederholen:" valign="center">
				<static-password cginame="FRM_PASSWORD_CHECK">
			</form-element>
			<form-defaultbuttons>
		<form-end>
	}]
	return "$result"
}


########################################################################


proc Form::deleteContent { {oldtitle {}} } {
	set result [subst -nocommands {
		<headline-page text="Wollen Sie diesen Fragebogen wirklich L&Ouml;SCHEN?">
		<body-paragraph>
			Klicken Sie auf [Fragebogen L&Ouml;SCHEN], wenn Sie den Fragebogen 
			mit dem Titel "$oldtitle" wirklich endg&uuml;ltig vernichten wollen.
		</body-paragraph>
		<body-paragraph class="important">
			ACHTUNG: Diese Aktion kann nicht r&uuml;ckgngig gemacht werden. Die 
			gel&ouml;schten Daten sind unwiderbringlich verloren und k&ouml;nnen nicht 
			wiederhergestellt werden.
		</body-paragraph>
		<form-begin>
			<form-parameterrefresh items="{FORMID FRM_PASSWORD}">
			<form-dboperation type="fbg_delete">
			<form-buttons submit="Fragebogen LSCHEN">
		<form-end>
	}]
	return "$result"
}


########################################################################


proc Form::editContent { {formid {}} } {
	set link [special2html [ComplexInput::generator_Link -plain]]
	set result [subst {
		<form-begin>
			<form-element label="Titel:">
				[DBOperations::get_Form_Title $formid]
			</form-element>
			<form-element label="Link:" valign="center">
				<form-text cginame="" value="$link">
			</form-element>
		<form-end>
		<form-begin>
			<form-parameterrefresh items="{FORMID FRM_PASSWORD}">
			<form-element label="Element:">
	}]
	
	set elementlist [DBOperations::build_Element_List $formid]
	if {[llength $elementlist] < 28} {
		set size 7
	} else {
		set size [expr "ceil([llength $elementlist] / 5)"]
	}
	if {$size < 2} {
		set size 2
	} elseif {$size > 20} {
		set size 20
	}
	append result [ComplexInput::listbox "$elementlist" "ORDERNO" "$size" "100%" "" "1"]
	
	append result {
			<form-element label="Aktion:">
				<static-formactionlist>
			</form-element>
			<form-element label="Elementtyp:" valign="center">
				<static-elementtypedropdown>
			</form-element>
			<form-defaultbuttons>
		<form-end>
	}
	return "$result"
}


########################################################################


proc Form::newContent {} {
	set result {
		<form-begin>
			<form-dboperation type="fbg_new">
			<template-formmiscinfo frm_title="Neuer Fragebogen">
			<form-defaultbuttons>
		<form-end>
	}
	return "$result"
}


########################################################################


proc Form::renameContent { {oldtitle {}} } {
	set result [subst {
		<body-paragraph>
			Geben Sie bitte den neuen Titel an, in den Sie den Fragebogen 
			mit dem bisherigen Titel "$oldtitle" umbenennen wollen.
		</body-paragraph>
		<form-begin>
			<form-parameterrefresh items="{FORMID FRM_PASSWORD}">
			<form-dboperation type="fbg_rename">
			<form-element label="Neuer Titel:" valign="center">
				<form-text cginame="FRM_TITLE">
			</form-element>
			<form-defaultbuttons>
		<form-end>
	}]
	return "$result"
}

