
variable formdata_attributes

# if you want to use other attributes in your database in the table
# containing the formdata, modify or add the following array. it's
# use is to disconnect the functionality from the names used for 
# attributes, to make changes at a later time more easy.
# all aliases must be in CAPITALS (see DBOperations::getAttributeName)

array set formdata_attributes {
	FRM_TITLE							FrmTitle
	FRM_DESCRIPTION					FrmDescription
	FRM_CREATED_ON						FrmCreatedOn
	FRM_CREATED_BY						FrmCreatedBy
	FRM_LAST_UPDATED					FrmLastUpdated
	FRM_SHOW_TITLE						FrmShowTitle
	FRM_BG_COLOR						FrmBgColor
	FRM_FG_COLOR						FrmFgColor
	FRM_PASSWORD						FrmPassword
	TXT_TEXT								TxtText
	TXT_ALIGNMENT						TxtAlignment
	TXT_SIZE								TxtSize
	TXT_COLOR							TxtColor
	TXT_LINK_TARGET					TxtLinkTarget
	SEP_TYPE								SepType
	SEP_DATA								SepData
	QST_NUMBER							QstNumber
	QST_SHOW_NUMBER					QstShowNumber
	QST_TEXT								QstText
	QST_ALIGNMENT						QstAlignment
	QST_ANSWER_ALIGNMENT				QstANSWERAlignment
	INP_TXT_LENGTH						InpTxtLength
	INP_TXT_WIDTH						InpTxtWidth
	INP_TXT_HEIGHT						InpTxtHeight
	INP_SEL_TYPE						InpSelType
	INP_SEL_OPTION_VALUES			InpSelOptionVALUEs
	INP_SEL_DEFAULT					InpSelDefault
	INP_SEL_ALIGN_TEXT				InpSelAlignText
	INP_SEL_ALIGN_OPTIONS			InpSelAlignOptions
	INP_SEL_BLOCK_VALUES				InpSelBlockVALUEs
	INP_SEL_SUB_QST_ALIGNMENT		InpSelSubQstAlignment
}	

########################################################################
# Semantics of the attributes:
#
# Attributes of a questionary:
#	FRM_TITLE							title of a questionairy
#	FRM_DESCRIPTION					description of a questionary
#	FRM_CREATED_ON						date and time of a questionary's creation
#	FRM_CREATED_BY						author of a questionary
#	FRM_LAST_UPDATED					date and time at which a questionary has been updatet
#	FRM_SHOW_TITLE						should the form's title be displayed?
#	FRM_BG_COLOR						the background color of a questionary
#	FRM_FG_COLOR						the text color of a questionary
#	FRM_PASSWORD						the password protecting a questionary
#
# Attributes of a text-block:
#	TXT_TEXT								the text of this block
#	TXT_ALIGNMENT						alignment of a text-block
#	TXT_SIZE								size of a text
#	TXT_COLOR							color of the text, overriding FRM_FG_COLOR
#	TXT_LINK_TARGET					link linking the text to a question
#
# Attributes of a seperator:
#	SEP_TYPE								kind of the seperator being used
#	SEP_DATA								data, defining the seperator more fully
#
# Attributes of a question:
#	QST_NUMBER							the number of a question
#	QST_SHOW_NUMBER					should the number be displayed with the question?
#	QST_TEXT								the question itself
#	QST_ALIGNMENT						alignment of the question
#	QST_ANSWER_ALIGNMENT				alignment of the question's answers
#
# Attributes of a question to be answered with free text:
#	INP_TXT_LENGTH						max length of the text to be entered
#	INP_TXT_WIDTH						width in chars of the input-element displayed 
#	INP_TXT_HEIGHT						height in rows of the input-element displayed 
#
# Attributes of a question to be answered by selecting an item from a list:
#	INP_SEL_TYPE						kind of the input-element being used
#	INP_SEL_OPTION_VALUES			a list of different answers
#	INP_SEL_DEFAULT					the default-answer
#	INP_SEL_ALIGN_TEXT				alignment of text around any input-elements
#	INP_SEL_ALIGN_OPTIONS			alignment of input-elements 
#
# Attributes of block-questions:
#	INP_SEL_BLOCK_VALUES				a list containing the block-questions
#	INP_SEL_SUB_QST_ALIGNMENT		alignment of the block-questions
