#!/usr/bin/tclsh

source cgi-args.tcl
source wshelp.tcl

proc cgi_br {} {
  puts "<br>\n"
}

proc cgi_p {} {
  puts "<p>\n"
}

proc status {} {

puts "<h1>Gefundene Werte</h1>\n"

puts "<h2>Pfad</h2>\n"
puts "Der Pfad ist [get_cgi_arg path]\n"

puts "<h2>Suchstring</h2>\n"
puts "Regex ist [get_cgi_arg regex]\n"

puts "<h2>Attribute</h2>\n"
puts "<ul>\n"
puts "<li>Title ist [get_cgi_arg title false].\n"
puts "<li>H1 ist [get_cgi_arg h1 false].\n"
puts "<li>H2 ist [get_cgi_arg h2 false].\n"
puts "<li>H3 ist [get_cgi_arg h3 false].\n"
puts "<li>Meta ist [get_cgi_arg meta false].\n"
puts "<li>Rest ist [get_cgi_arg Rest false].\n"
puts "</ul>\n"

puts "<h2>Debug-Ausgaben</h2>\n"

puts "Debug-Ausgaben ist [get_cgi_arg debug false].\n"

}


proc get_tree {} {

  global DOCUMENT_ROOT 

  set base_dir [get_cgi_arg path "/"]

  set base_dir "${DOCUMENT_ROOT}${base_dir}"

  if {![file isdirectory $base_dir]} {
    puts "<h2>directory \"$base_dir\" not found.</h2>\n"
    puts "</body>\n</html>\n"
    exit 1 
  }

  set result ""

  return [find $base_dir "\\.html"]

}


proc do_search {fname regex} {
  set buf [read_file $fname]
  set buf [join_tags $buf]

  #puts "<p>reading $fname...<p>"
  #puts "$buf"

  if {"[get_cgi_arg rest false]" != "false"} {
    if {[regexp -nocase "$regex" $buf]} {
      return 1
    }
  } elseif {"[get_cgi_arg title false]" != "false"} {
    if {[regexp -nocase "\ntitle>\[^\n\]*$regex" $buf]} {
      return 1
    }
  } elseif {"[get_cgi_arg h1 false]" != "false"} {
    if {[regexp -nocase "\nh1>\[^\n\]*$regex" $buf]} {
      return 1
    }
  } elseif {"[get_cgi_arg h2 false]" != "false"} {
    if {[regexp -nocase "\nh2>\[^\n\]*$regex" $buf]} {
      return 1
    }
  } elseif {"[get_cgi_arg h3 false]" != "false"} {
    if {[regexp -nocase "\nh3>\[^\n\]*$regex" $buf]} {
      return 1
    }
  } elseif {"[get_cgi_arg meta false]" != "false"} {
    if {[regexp -nocase "\nmeta\[^\n\]*$regex.*>" $buf]} {
      return 1
    }
  }

  #puts "<p><strong>nope!</strong><p>"
  return 0
}

# #########################################################################
# main ()
#

set debug [get_cgi_arg debug "false"]
set regex [get_cgi_arg regex ""]

puts "Content-type: text/html\n\n"
puts "<html><header>WebSearch: Suchergebnisse</header>\n<body>\n"

if {"$debug" != "false"} {
	status
	cgi_p
}

puts "<h1>Suchergebnisse</h1>"
puts "Der Suchausdruck \"$regex\" wurde in folgenden Dateien gefunden:\n"
puts "<ul>"
set found 0
foreach fname [get_tree] {
  #puts "It's $fname<br>"
  if {[do_search $fname $regex]} {
    regsub ${DOCUMENT_ROOT} ${fname} "" fname
    puts "<li><a href=\"$fname\">$fname</a>"
    set found 1
  }
}

if {"$found" == "0"} {
  puts "<strong>Keine Eintr&auml;ge gefunden!</strong>"
}
puts "</ul>"
puts "<p>Das wars's!\n"
puts "<hr><div align=right><author>"
puts "<a href=\"mailto:herbert@fh-wedel.de,gla@fh-wedel.de\">Herbert und Heiko</a>"
puts "</author></div>"

puts "</body>\n</html>\n"

